<template>
    <div class="app-container">
        <el-row :gutter="20" :loading="pageLoading">
            <el-col :lg="16" :md="16" :sm="24">
                <div class="paper grid">
                    <h3>{{ pageTitle[pageStatus] }}</h3>
                    <el-form ref="documentForm" :model="documentForm" :rules="documentRules">
                        <aside>
                            <el-alert type="info" description="Add or edit document" :closable=false show-icon></el-alert>
                        </aside>
                        <el-row :gutter="20">
                            <el-col :lg="12" :md="12" :sm="24">
                                <el-form-item label="Document Number" prop="document_number">
                                    <el-input ref="document_number" name="document_number" v-model="documentForm.document_number" placeholder="Document number" autocomplete="off" maxlength="45" class="has-suffix" :disabled="isArchive" show-word-limit></el-input>
                                </el-form-item>
                            </el-col>
                            <el-col :lg="12" :md="12" :sm="24">
                                <el-form-item label="Title" prop="title">
                                    <el-input ref="title" name="title" v-model="documentForm.title" placeholder="Title of the document" autocomplete="off" maxlength="255" class="has-suffix" :disabled="isArchive" show-word-limit></el-input>
                                </el-form-item>
                            </el-col>
                        </el-row>
                        <el-row :gutter="20">
                            <el-col :lg="24" :md="24" :sm="24" v-if="user.role.slug == 'root'">
                                <el-form-item label="Remarks" prop="remarks">
                                    <el-input type="textarea" ref="remarks" name="remarks" v-model="documentForm.remarks" placeholder="Write something here..." :disabled="isArchive" autocomplete="off"></el-input>
                                </el-form-item>
                            </el-col>                            
                        </el-row> 
                        <div v-if="selectedGroupFieldsObject.length > 0">  
                            <div class="custom-field" v-for="(cf, i) in selectedGroupFieldsObject" :key="i">
                                <h3>{{ cf.name }}</h3>
                                <span class="display-block">{{ cf.description }}</span>
                                <el-row :gutter="20" v-for="j in Math.ceil(cf.fields.length / 2)" :key="j">
                                    <el-col :lg="12" :md="12" :sm="24" v-for="(field, index) in cf.fields.slice((j - 1) * 2, j * 2)" :key="index">

                                        <el-form-item v-if="['text', 'email', 'number', 'textarea'].indexOf(field.field) > -1" :type="field.field" :label="field.name" :prop="field.slug+'_'+field.id.toString()">
                                            <el-input :ref="field.slug" :name="field.slug" v-model="field.value" :placeholder="field.description" autocomplete="off" :disabled="isArchive"></el-input>
                                        </el-form-item>

                                        <el-form-item v-else-if="field.field == 'checkbox'" :label="field.name" :prop="field.slug+'_'+field.id.toString()">
                                            <el-checkbox-group v-model="field.value">
                                                <el-checkbox v-for="(option, checkboxIndex) in field.options.split('\n')" :key="checkboxIndex" :label="option" :disabled="isArchive"></el-checkbox>
                                            </el-checkbox-group>
                                        </el-form-item>

                                        <el-form-item v-else-if="field.field == 'radio'" :label="field.name" :prop="field.slug+'_'+field.id.toString()">
                                            <el-radio-group v-model="field.value">
                                                <el-radio v-for="(option, radioIndex) in field.options.split('\n')" :key="radioIndex" :label="option" :disabled="isArchive"></el-radio>
                                            </el-radio-group>
                                        </el-form-item>

                                        <el-form-item v-else-if="field.field == 'select'" :label="field.name" :prop="field.slug+'_'+field.id.toString()">
                                            <el-select
                                                :disabled="isArchive"
                                                :ref="field.slug+'_'+field.id.toString()"
                                                :name="field.slug+'_'+field.id.toString()"
                                                class="width-100"
                                                v-model="field.value"
                                                value-key="id"
                                                :placeholder="field.description"
                                                no-data-text="No Data"
                                                clearable>
                                                <el-option
                                                    v-for="(item, selectIndex) in field.options.split('\n')"
                                                    :key="selectIndex"
                                                    :label="item"
                                                    :value="item">                        
                                                </el-option>
                                            </el-select>
                                            <el-checkbox-group v-model="field.value">
                                                <el-checkbox v-for="(option, checkboxIndex) in field.options.split('\n')" :key="checkboxIndex" :label="option" :disabled="isArchive"></el-checkbox>
                                            </el-checkbox-group>
                                        </el-form-item>
                                        
                                        <el-form-item v-else-if="field.field == 'datepicker'" :label="field.name" :prop="field.slug+'_'+field.id.toString()">
                                            <el-date-picker
                                            :disabled="isArchive"
                                            v-model="field.value"
                                            format="yyyy-MM-dd"
                                            type="date"
                                            :placeholder="field.description"
                                            :editable="false">
                                            </el-date-picker>
                                        </el-form-item>

                                        <el-form-item v-else-if="field.field == 'datetimepicker'" :label="field.name" :prop="field.slug+'_'+field.id.toString()">
                                            <el-date-picker
                                            :disabled="isArchive"
                                            v-model="field.value"
                                            format="yyyy-MM-dd HH:mm"
                                            type="datetime"
                                            :placeholder="field.description"
                                            :editable="false">
                                            </el-date-picker>
                                        </el-form-item>

                                        <el-form-item v-else-if="field.field == 'timepicker'" :label="field.name" :prop="field.slug+'_'+field.id.toString()">
                                            <el-time-select
                                            :disabled="isArchive"
                                            v-model="field.value"
                                            :picker-options="{
                                                start: '00:00',
                                                step: '00:5'
                                            }"
                                            :placeholder="field.description"
                                            :editable="false">
                                            </el-time-select>
                                        </el-form-item>
                                    </el-col>
                                </el-row>
                            </div>
                        </div>
                        <h3>Person Involved</h3>
                        <div v-for="(person, index) of documentForm.persons" :key="index" class="dynamic-list">
                            <el-row :gutter="20">
                                <el-col :lg="12" :md="12" :sm="24">
                                    <el-form-item label="Full Name" prop="fullname">
                                        <el-input ref="fullname" name="fullname" v-model="person.fullname" placeholder="Person full name" autocomplete="off" maxlength="45" class="has-suffix" :disabled="isArchive" show-word-limit></el-input>
                                    </el-form-item>
                                </el-col>
                                <el-col :lg="12" :md="12" :sm="24">
                                    <el-form-item label="Phone" prop="phone">
                                        <el-input type="number" ref="phone" name="phone" v-model="person.phone" placeholder="08xxxxxxxxxxx" autocomplete="off" maxlength="25" class="has-suffix" :disabled="isArchive" show-word-limit></el-input>
                                    </el-form-item>
                                </el-col>
                            </el-row>
                            <el-form-item>
                                <el-button class="float-right" @click="addPerson" v-if="(index + 1) == documentForm.persons.length && !isArchive" icon="el-icon-plus" type="success" size="mini"> Add</el-button>
                                <el-button class="float-right" @click="deletePerson(index)" v-else-if="!isArchive" icon="el-icon-delete" type="danger" size="mini">Delete </el-button>
                            </el-form-item>
                        </div>            
                    </el-form>
                    <br>
                    <div slot="footer" class="dialog-footer">
                        <el-button @click="$router.go(-1)" size="medium"><i class="ion-ios-close-circle-outline"></i> Cancel</el-button>
                        <el-button v-if="!isArchive" v-permission="[null, 'document', 'editother']" @click="handleSubmit" size="medium" type="success">
                            <i class="ion-ios-checkmark-circle"></i> {{ pageTitle[pageStatus] }}
                        </el-button>
                        <el-button v-if="pageStatus=='edit' && !isArchive" v-permission="[null, 'document', 'editother']" @click="handleArchive" size="medium" type="info">
                            <i class="ion-ios-archive"></i> Archive
                        </el-button>
                        <el-button v-else-if="pageStatus=='edit' && isArchive" v-permission="[null, 'document', 'editother']" @click="handleUnarchive" size="medium" type="info">
                            <i class="ion-ios-archive"></i> Unarchive
                        </el-button>
                    </div>
                </div>                
            </el-col>
            <el-col :lg="8" :md="8" :sm="24">
                <div class="paper grid margin-small-bottom" v-if="user.role.slug == 'root'">
                    <h3>Attributes</h3>
                    <span class="display-block margin-small-bottom" style="font-size:14px;">Author</span>
                    <el-select
                        :disabled="isArchive"
                        ref="author"
                        name="author"
                        class="width-100"
                        clearable
                        filterable
                        remote
                        :remote-method="getAuthors"
                        v-model="documentForm.author"
                        value-key="id"
                        placeholder="Type username"
                        no-data-text="No Record Found"
                        :loading="authorLoading"
                        @clear="handleClearAuthor()"
                        @change="handleAuthorChange($event)">
                        <el-option
                            v-for="item in authors"
                            :key="item.id"
                            :label="item.fullname.capitalize()"
                            :value="item.id">     
                            <span style="float: left">{{ item.fullname.capitalize() }}</span>
                            <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.code }}</strong>                   
                        </el-option>
                    </el-select>
                    <div class="display-block margin-small-top" v-if="customFields.length">
                        <span class="display-block margin-small-bottom" style="font-size:14px;">Custom Fields</span>
                        <el-select
                            :disabled="isArchive"
                            class="width-100"  
                            v-model="selectedGroupFieldsValue"
                            multiple
                            placeholder="Select custom field"
                            @change="handleCustomFieldChange">
                            <el-option
                                v-for="item in customFields"
                                :key="item.id"
                                :label="item.name"
                                :value="item.id">
                            </el-option>
                        </el-select>
                    </div>
                    <div class="display-block margin-small-top" v-if="statuses.length">
                        <span class="display-block margin-small-bottom" style="font-size:14px;">Status</span>
                        <el-select
                            :disabled="isArchive"
                            class="width-100"  
                            v-model="documentForm.status"
                            placeholder="Select status">
                            <el-option
                                v-for="item in statuses"
                                :key="item.id"
                                :label="item.name"
                                :value="item.id">
                            </el-option>
                        </el-select>                        
                        <div class="display-block margin-medium-top">
                            <el-input type="textarea" ref="note" name="note" v-model="documentForm.statusNote" placeholder="Write a note" autocomplete="off" autosize :disabled="isArchive"></el-input>
                        </div>
                        <div class="display-block margin-medium-top">
                            <el-switch
                                v-model="documentForm.statusNotification"
                                active-text="Notify Person Involved"
                                inactive-text="Keep Silent"
                                :disabled="isArchive">
                            </el-switch>
                        </div>
                    </div>
                </div>
                <div class="paper grid margin-small-bottom">
                    <h3>Attachments</h3>
                    <el-upload
                        v-if="!isArchive"
                        name="media"
                        :action="uploadURL"
                        with-credentials
                        accept=" .jpg, .jpeg, .png, .doc, .docx, .xls, .xlsx, .pdf"
                        :headers="{'Authorization': 'Bearer ' + token.access_token}"
                        :on-success="handleUploadSuccess"
                        :on-remove="handleUploadRemove"
                        :on-preview="handleUploadPreview"
                        :before-remove="handleBeforeRemove"
                        :before-upload="beforeUpload"
                        :file-list="uploadFileList">
                        <el-button size="small" type="primary">Upload</el-button>
                        <div slot="tip" class="el-upload__tip">File type: jpg, png, doc/docx, xls/xlsx, pdf</div>
                    </el-upload>
                </div>
                <div class="paper grid margin-small-bottom" v-if="document != null && document.statuses.length > 0">
                    <h3>Current Status</h3>
                    <el-timeline class="no-padding">
                        <el-timeline-item
                            v-for="(status, index) in document.statuses" 
                            :key="index"
                            :timestamp="dateFormat(status.created)"
                            placement="top">
                                <h4 style="margin:0;">{{ status.status.name }} <i class="ion-ios-notifications" style="color:#E65D6E;" v-if="status.notified"></i></h4>
                                <small style="font-sze:12px;">Updated by: {{ status.author.fullname.capitalize() }}</small>
                                <p>{{ status.note }}</p>
                        </el-timeline-item>
                    </el-timeline>                    
                </div>
                <div class="paper grid margin-small-bottom" v-if="document != null">
                    <el-row :gutter="20">
                        <el-col :lg="8" :md="8" :sm="24" class="text-align-center qrcode">
                            <qrcode ref="qr" :value="document.tracking_number" :options="{ width: 125 }" tag="img"></qrcode>
                        </el-col>
                        <el-col :lg="16" :md="16" :sm="24">
                            <small style="display:block;margin-top:10px;margin-bottom:5px;">Tracking Number</small>
                            <h4 class="no-margin-top">{{ document.tracking_number }}</h4>
                            <el-button @click="handlePrint()" type="primary" size="mini"><i class="ion-ios-print"></i> Print QRCode</el-button>
                        </el-col>
                    </el-row>
                </div>                
            </el-col>
        </el-row>
    </div>
</template>
<script>
import html2pdf from 'html2pdf.js';
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import { parseError, dateFormat, convertAmpersand } from '../../utils/index';
import { setTimeout } from 'timers';
export default {
    name: 'DocumentForm',
    directives: {
        permission
    },
    data(){

        var validateAuthor = (rule, value, callback) => {
            if(this.user.role.slug == 'root' && this.documentForm.author == null){
                return callback(new Error('Author is required'));
            }
            callback();
        };

        return {
            pageLoading: true,
            authorLoading: false,
            pageStatus: '',
            pageTitle: {
                edit: 'Edit Document',
                add: 'Add New Document'
            },
            documentForm: {
                id: null,
                document_number: '',
                title: '',
                remarks: '',
                author: null,
                fields: {},
                status: null,
                statusNotification: false,
                statusNote: null,
                persons: [{
                    fullname: '',
                    phone: ''
                }],
                medias: []
            },
            documentRules: {
                document_number: [{ 
                    required: true, message: 'Document number is required', trigger: 'blur'
                }, {
                    max: 45, message: 'Document number length 45 characters', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9&()-\s./]{1,45})$/, 
                    message: 'Only letters, numbers, ampersand, brackets and spaces are allowed.', 
                    trigger: 'blur'
                }],
                title: [{ 
                    required: true, message: 'Document title is required', trigger: 'blur'
                }, {
                    max: 255, message: 'Document title length 45 characters', trigger: 'blur'
                }],
                author: [{ 
                    validator: validateAuthor, trigger: 'change'
                }]
            },
            selectedGroupFieldsValue: [],
            selectedGroupFieldsObject: [],
            selectedCustomFields: {},
            uploadFileList: [],
            uploadURL: '',
            isArchive: false
        }
    },
    computed: {
        ...mapGetters('auth', ['user', 'token']),
        ...mapGetters('user', ['authors']),
        ...mapGetters('status', [
            'statuses'
        ]),
        ...mapGetters('customfield', [
            'customFields'
        ]),
        ...mapGetters('document', [
            'document'
        ])
    },
    created(){
        const self = this;

        self.$store.dispatch('document/resetDocument');

        if(self.$route.params.id){
            self.pageStatus = 'edit';

            self.$store.dispatch('document/viewDocument', {
                id: self.$route.params.id
            }).then(()=>{

                self.isArchive = self.document.isarchived;

                self.uploadURL = 'http://api.doctrin.pusri.co.id/v1/media/documents/'+self.document.id;

                self.documentForm.id = self.document.id;
                self.documentForm.document_number = self.document.document_number;
                self.documentForm.title = convertAmpersand(self.document.title);
                self.documentForm.remarks = self.document.remarks != null ? convertAmpersand(self.document.remarks) : null;
                self.documentForm.author = self.document.author.id;

                self.getAuthors(self.document.author.fullname, true);

                if(self.document.person_involves.length){
                    self.documentForm.persons = [];
                    for(const x of self.document.person_involves){
                        self.documentForm.persons.push({
                            fullname: x.fullname,
                            phone: x.phone
                        });
                    }
                }

                // if(self.document.author.organization != null){
                //     setTimeout(()=>{
                //         self.handleAuthorChange(self.document.author.id, true);                         
                //     }, 1000);
                // }                

                if(self.document.medias != null){
                    for(const i of self.document.medias){
                        self.documentForm.medias.push(i.id);
                        self.uploadFileList.push({
                            id: i.id,
                            name: i.original_filename,
                            url: i.url.original
                        });
                    }
                }else{
                    self.documentForm.medias = self.document.medias;
                }
            });

        }else{
            self.uploadURL = 'http://api.doctrin.pusri.co.id/v1/media/tmp';
            self.pageStatus = 'add';
        }        
    },
    methods: {
        dateFormat,
        convertAmpersand,
        getStatuses(organizationId){
            const self = this;

            if(!organizationId) return;

            self.$store.dispatch('status/getStatuses', {
                organization_id: organizationId,
                loadmore: false
            });
        },
        getCustomFields(organizationId, editMode){
            
            const self = this;

            editMode = editMode || false;

            if(!organizationId) return;

            self.$store.dispatch('customfield/getCustomFields', {
                organization_id: organizationId,
                loadmore: false
            }).then(()=>{
                if(editMode && self.document.custom_fields.length){
                    for(const x of self.document.custom_fields){
                        if(self.selectedGroupFieldsValue.indexOf(x.fields.group.id) == -1){
                            self.selectedGroupFieldsValue.push(x.fields.group.id);
                        } 
                        self.selectedCustomFields[x.fields.id] = x.value;                       
                    }

                    self.handleCustomFieldChange(editMode);
                    
                }
            });
        },
        getAuthors(q, editMode){
            const self = this;

            editMode = editMode || false;

            if(q.length >= 3){
                self.authorLoading = true;
                self.$store.dispatch('user/getAuthors', {
                    q: q,
                    page: 1,
                    perpage: 25,
                    exclude: 'role'
                }).then(() => {
                    self.authorLoading = false;
                    setTimeout(()=>{

                        if(editMode){
                            self.handleAuthorChange(self.document.author.id, true);
                        }

                    }, 300);                 
                });
            }
        },
        handleArchive(){
            const self = this;

            self.$confirm('You are about to save this document to the archive. Are you sure?', 'Warning', {
                confirmButtonText: 'Yes, I\'m Sure',
                cancelButtonText: 'Cancel'
            }).then(()=>{
                self.pageLoading = true;
                self.$store.dispatch('document/deleteDocument', {
                    id: self.document.id
                }).then((response) => {
                    self.pageLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        self.$message.error({
                            message: error.messages
                        });
                    }else{
                        self.$message.success({
                            message: response.message
                        });

                        self.$router.push('onprogress');
                    }
                });
            });
        },
        handleUnarchive(){
            const self = this;

            self.$confirm('You are about to unarchive this document. Are you sure?', 'Warning', {
                confirmButtonText: 'Yes, I\'m Sure',
                cancelButtonText: 'Cancel'
            }).then(()=>{
                self.pageLoading = true;
                self.$store.dispatch('document/unarchiveDocument', {
                    id: self.document.id
                }).then((response) => {
                    self.pageLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        self.$message.error({
                            message: error.messages
                        });
                    }else{
                        self.$message.success({
                            message: response.message
                        });

                        self.$router.push('archives');
                    }
                });
            });
        },
        handleSubmit(){
            const self = this;

            self.$refs.documentForm.validate((valid)=>{
                if(valid){
                    self.pageLoading = true;

                    let fields = [];

                    if(self.selectedGroupFieldsObject.length){
                        for(const x of self.selectedGroupFieldsObject){
                            for(const i of x.fields){
                                fields.push({
                                    id: i.id,
                                    value: Array.isArray(i.value) ? i.value.join('\n') : i.value
                                });
                            }
                        }
                    }

                    let action = 'document/addDocument';
                    let params = {
                        document_number: self.documentForm.document_number,
                        title: self.documentForm.title,
                        remarks: self.documentForm.remarks,
                        author: self.user.role.slug == 'root' ? self.documentForm.author : self.user.id,
                        persons: self.documentForm.persons,
                        status: self.documentForm.status,
                        notified: self.documentForm.statusNotification,
                        note: self.documentForm.statusNote,
                        fields: fields.length > 0 ? fields : null
                    };

                    if(self.pageStatus == 'edit'){
                        action = 'document/editDocument';
                        params.id = self.documentForm.id;
                    }else{
                        params.medias = self.documentForm.medias;
                    }

                    self.$store.dispatch(action, params).then((response)=>{
                        self.pageLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            self.$message.error({
                                message: error.messages
                            });
                        }else{
                            self.$message.success({
                                message: response.message
                            });

                            self.resetForm();
                            self.$router.push('onprogress');
                        }
                    });
                }else{
                    return false;
                }
            });
        },
        resetForm() {
            const self = this;

            self.documentForm = {
                id: null,
                document_number: '',
                title: '',
                remarks: '',
                author: null,
                fields: [],
                status: null,
                statusNotification: false,
                statusNote: null,
                persons: [],
                medias: []
            };

            self.uploadFileList = [];

            self.handleClearAuthor();
            self.$store.dispatch('status/resetStatuses');
            self.$store.dispatch('customfield/resetCustomFields');
        },
        handleClearAuthor(){
            const self = this;
            self.documentForm.author = null;
            self.selectedGroupFieldsObject = [];
            self.selectedGroupFieldsValue = [];
            self.$store.dispatch('user/resetAuthors');
        },
        handleAuthorChange(authorId, editMode){
            
            const self = this;

            editMode = editMode || false;

            if(authorId){
                let author = self.authors.filter((x)=>x.id == authorId)[0];
                if(author.organization != null){
                    self.getCustomFields(author.organization.id, editMode);
                    self.getStatuses(author.organization.id);
                }
            }else{
                self.$store.dispatch('status/resetStatuses');
                self.$store.dispatch('customfield/resetCustomFields');
            }                   
        },
        handleCustomFieldChange(editMode){
            const self = this;

            editMode = editMode || false;
            
            if(self.selectedGroupFieldsValue.length){
                //tricky: reset selected group fields object
                self.selectedGroupFieldsObject = [];

                for(let x of self.customFields){
                    if(self.selectedGroupFieldsValue.indexOf(x.id) > -1){
                        let group = x;
                        for(let [index, i] of group.fields.entries()){
                            if(['checkbox', 'radio'].indexOf(i.field) > -1){
                                group.fields[index].value = [];
                            }
                        }
                        self.selectedGroupFieldsObject.push(group);
                    }                    
                }

                if(editMode && self.selectedGroupFieldsObject.length > 0){
                    for(const [index, x] of self.selectedGroupFieldsObject.entries()){
                        for(const [idx, i] of x.fields.entries()){
                            if(self.selectedCustomFields.hasOwnProperty(i.id)){
                                if(Array.isArray(self.selectedGroupFieldsObject[index].fields[idx].value)){
                                    self.selectedGroupFieldsObject[index].fields[idx].value = self.selectedCustomFields[i.id].split('\n');
                                }else{
                                    self.selectedGroupFieldsObject[index].fields[idx].value = self.selectedCustomFields[i.id];
                                }
                                
                            }                                
                        }
                    }
                }

            }else{
                self.selectedGroupFieldsObject = [];
                self.documentForm.fields = {};
            }                     
        },
        addPerson() {
            const self = this;
            self.documentForm.persons.push({
                fullname: '',
                phone: ''
            });
        },
        deletePerson(index) {
            const self = this;
            for(const [i, v] of self.documentForm.persons.entries()){
                if(i == index){
                    self.documentForm.persons.splice(i, 1);                    
                    break;
                }
            }
        },
        beforeUpload(file) {
            const self = this;

            if (['image/jpeg', 'image/png', 'application/pdf', 'application/msword', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document', 'application/vnd.ms-excel', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet', 'application/wps-office.docx', 'application/wps-office.doc', 'application/wps-office.xlsx', 'application/wps-office.xls',].indexOf(file.type) < 0) {
                self.$message.error('Only file with type jpg, png, doc/docx, xls/xlsx and pdf are allowed.');
                return false;
            }
            if (file.size > (8 * 1024 * 1024)) {
                self.$message.error('File size cannot bigger than 8MB.');
                return false;
            }
            return true;
        },
        handleUploadSuccess(res) {
            const self = this;
            self.documentForm.medias.push(res.data.media.id);
            self.uploadFileList.push({
                name: res.data.media.original_filename,
                id: res.data.media.id
            });
        },
        handleBeforeRemove(){
            const self = this;
            return self.$confirm('Delete this attachment file? This operation cannot be undone', 'Warning', {
                confirmButtonText: 'OK',
                cancelButtonText: 'Cancel',
            });
        },
        handleUploadRemove(file){
            const self = this;

            let action = '';
            let params = {};

            if(self.pageStatus == 'add'){
                action = 'media/deleteMedia';
                params.id = file.id;
            }else{
                action = 'media/deleteMediaDocument';
                params.id = file.id;
            }

            self.$store.dispatch(action, params).then((response) => {
                if('errors' in response){
                    let error = parseError(response.errors);
                    self.$message.error({
                        message: error.messages
                    });
                }else{
                    self.$message.success({
                        message: response.message
                    });
                }
            });
        },
        handleUploadPreview(file){
            var a = document.createElement("a");
            a.href = file.url;
            a.setAttribute("download", file.name);
            a.click();
        },
        handlePrint(){
            const self = this;

            var html = `<div style="padding:0;margin:0;display:block;text-align:center;font-size:13px!important;line-height:1.6em;color:#222;position:relative">
                            <div style="position:absolute;top:0px;left:50%;margin-left:-75px;z-index:99;"><img src="${require('../../assets/logo-pusri.png')}" width="150"></div>
                            <div><img src="${self.$refs.qr.$el.src}" width="300"></div>
                            <small style="position:absolute;bottom:10px;left:50%;margin-left:-75px;z-index:99;font-size:16px;">${self.document.tracking_number.toUpperCase()}</small>
                        </div>`;

            var opt = {
                filename: self.document.tracking_number+'.pdf',
                image: { type: 'jpeg', quality: 0.98 },
                pagebreak: { mode: ['avoid-all', 'css', 'legacy'] },
                html2canvas: { scale: 2 },
                jsPDF: { unit: 'in', format: 'a5', orientation: 'portrait' }
            };

            // New Promise-based usage:
            html2pdf().setMargin(0.4).set(opt).from(html).save();
        }
    }
}
</script>